DECLARE
  cnt integer;
BEGIN
  SELECT count(*) INTO cnt 
    FROM user_views WHERE lower(view_name)='layers_nonsynchr';
  IF cnt>0 THEN
    EXECUTE IMMEDIATE 'DROP VIEW Layers_NonSynchr';
  END IF;
  
  SELECT count(*) INTO cnt 
    FROM user_tables WHERE lower(table_name)='layers_nonsynchr';
  IF cnt=0  THEN
    EXECUTE IMMEDIATE 'CREATE TABLE Layers_NonSynchr 
   (	
  	ID NUMBER(10,0) NOT NULL, 
	  LAYERREF NUMBER(10,0) NOT NULL, 
	  LAYERVERSION NUMBER(10,0) NOT NULL, 
    ASSEMBLY NUMBER(10,0),
    CREATEDATE DATE NOT NULL, 
	  CREATERUSER VARCHAR2(30) NOT NULL, 
	  UPDATEDATE DATE NOT NULL, 
	  UPDATERUSER VARCHAR2(30) NOT NULL, 
    
	
	 CHECK ((ID<=2147483647)AND(ID>-2147483648)) ENABLE, 
	 CHECK ((LayerRef<=2147483647)AND(LayerRef>-2147483648)) ENABLE, 
	 CHECK ((LayerVersion<=2147483647)AND(LayerVersion>-2147483648)) ENABLE, 
	 CHECK ((ASSEMBLY<=2147483647)AND(ASSEMBLY>-2147483648)) ENABLE, 
  
   CONSTRAINT "PK_L_NS" PRIMARY KEY ("ID")
   )';
   
   EXECUTE IMMEDIATE 'CREATE INDEX L_NS_Layer ON Layers_NonSynchr(LayerRef)';
   EXECUTE IMMEDIATE 'CREATE INDEX L_NS_LayerVersion ON Layers_NonSynchr(LayerRef,LayerVersion)';
   
   EXECUTE IMMEDIATE 'GRANT ALL ON Layers_NonSynchr TO PUBLIC';
   
   EXECUTE IMMEDIATE 'INSERT INTO Layers_NonSynchr
    SELECT ID,INTFIELD00,INTFIELD01,INTFIELD02,
       CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER FROM
    LayerData WHERE LayerRef=(SELECT ID FROM Layers WHERE ALIAS=''..'')';

  EXECUTE IMMEDIATE 'UPDATE Layers SET TableName=''Layers_NonSynchr''
   WHERE ALIAS=''..''';

  END IF;
END;
/


CREATE OR REPLACE TRIGGER "TR_L_NS_BI" 
 BEFORE
  INSERT
 ON Layers_NonSynchr
REFERENCING NEW AS NEW OLD AS OLD
 FOR EACH ROW
declare
  fac NUMBER(10);
begin
  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;
end;
/

CREATE OR REPLACE TRIGGER "TR_L_NS_BU_500" before update on Layers_NonSynchr for each row
begin
-- - - - - - - - - - - - -
-- BU_500
-- - - - - - - - - - - - -
    :new.UpdateDate := SYSDATE;
    :new.UpdaterUser := User;
end;
/

